function round(x,   ival, aval, fraction)
     {
        ival = int(x)    # integer part, int() truncates
     
        # see if fractional part
        if (ival == x)   # no fraction
           return ival   # ensure no decimals
     
        if (x < 0) {
           aval = -x     # absolute value
           ival = int(aval)
           fraction = aval - ival
           if (fraction >= .5)
              return int(x) - 1   # -2.5 --> -3
           else
              return int(x)       # -2.3 --> -2
        } else {
           fraction = x - ival
           if (fraction >= .5)
              return ival + 1
           else
              return ival
        }
     }

BEGIN{
   total = 0
}

/BUILD:ERROR_COMMENT/{
    if (($NF != "not_needed") && ($NF != "NONE")) {
      A[$NF] = (A[$NF]+0) + 1
      total++
    }
}
END {
    print "\\begin{tabular}{lcr}\\toprule"
    print "error & count & percentage \\\\\\\midrule"
    for (i in A) {
       l = tolower(i)
       gsub("_"," ",l)
       print "   " l " & " A[i] " & " round(1000*A[i]/total)/10.0 "\\% \\\\"
    }
   print "\\midrule"
   print "Total & " total " & \\\\"
   print "\\bottomrule"
   print "\\end{tabular}"
}
