#!/usr/local/bin/python3.3

import numpy as np
import matplotlib.pyplot as plt
from pylab import *
from matplotlib.sankey import Sankey

##################################################################
# This code has been inserted automatically.
TissecNSF = 13
TissecWithImplementation = 6
TissecWithImplementationPercentOfNSF = 46.2
TissecWithNoImplementation = 7
TissecWithNoImplementationPercentOfNSF = 53.8
TissecWithAvailableCode = 4
TissecWithAvailableCodePercentOfImplementation = 66.7
TissecWithNoAvailableCode = 2
TissecWithNoAvailableCodePercentOfImplementation = 33.3
TissecWithArticleCode = 3
TissecWithArticleCodePercentOfImplementation = 50.0
TissecWithArticleCodePercentOfAvailableCode = 75.0
TissecWithGoogleCode = 0
TissecWithGoogleCodePercentOfImplementation = 0.0
TissecWithGoogleCodePercentOfAvailableCode = 0.0
TissecWithEmailCode = 1
TissecWithEmailCodePercentOfImplementation = 16.7
TissecWithEmailCodePercentOfAvailableCode = 25.0
TacoNSF = 60
TacoWithImplementation = 39
TacoWithImplementationPercentOfNSF = 65.0
TacoWithNoImplementation = 21
TacoWithNoImplementationPercentOfNSF = 35.0
TacoWithAvailableCode = 14
TacoWithAvailableCodePercentOfImplementation = 35.9
TacoWithNoAvailableCode = 25
TacoWithNoAvailableCodePercentOfImplementation = 64.1
TacoWithArticleCode = 7
TacoWithArticleCodePercentOfImplementation = 17.9
TacoWithArticleCodePercentOfAvailableCode = 50.0
TacoWithGoogleCode = 3
TacoWithGoogleCodePercentOfImplementation = 7.7
TacoWithGoogleCodePercentOfAvailableCode = 21.4
TacoWithEmailCode = 4
TacoWithEmailCodePercentOfImplementation = 10.3
TacoWithEmailCodePercentOfAvailableCode = 28.6
TodsNSF = 29
TodsWithImplementation = 17
TodsWithImplementationPercentOfNSF = 58.6
TodsWithNoImplementation = 12
TodsWithNoImplementationPercentOfNSF = 41.4
TodsWithAvailableCode = 8
TodsWithAvailableCodePercentOfImplementation = 47.1
TodsWithNoAvailableCode = 9
TodsWithNoAvailableCodePercentOfImplementation = 52.9
TodsWithArticleCode = 1
TodsWithArticleCodePercentOfImplementation = 5.9
TodsWithArticleCodePercentOfAvailableCode = 12.5
TodsWithGoogleCode = 5
TodsWithGoogleCodePercentOfImplementation = 29.4
TodsWithGoogleCodePercentOfAvailableCode = 62.5
TodsWithEmailCode = 2
TodsWithEmailCodePercentOfImplementation = 11.8
TodsWithEmailCodePercentOfAvailableCode = 25.0
OsdiNSF = 24
OsdiWithImplementation = 24
OsdiWithImplementationPercentOfNSF = 100.0
OsdiWithNoImplementation = 0
OsdiWithNoImplementationPercentOfNSF = 0.0
OsdiWithAvailableCode = 10
OsdiWithAvailableCodePercentOfImplementation = 41.7
OsdiWithNoAvailableCode = 14
OsdiWithNoAvailableCodePercentOfImplementation = 58.3
OsdiWithArticleCode = 4
OsdiWithArticleCodePercentOfImplementation = 16.7
OsdiWithArticleCodePercentOfAvailableCode = 40.0
OsdiWithGoogleCode = 4
OsdiWithGoogleCodePercentOfImplementation = 16.7
OsdiWithGoogleCodePercentOfAvailableCode = 40.0
OsdiWithEmailCode = 2
OsdiWithEmailCodePercentOfImplementation = 8.3
OsdiWithEmailCodePercentOfAvailableCode = 20.0
SigmodNSF = 46
SigmodWithImplementation = 45
SigmodWithImplementationPercentOfNSF = 97.8
SigmodWithNoImplementation = 1
SigmodWithNoImplementationPercentOfNSF = 2.2
SigmodWithAvailableCode = 17
SigmodWithAvailableCodePercentOfImplementation = 37.8
SigmodWithNoAvailableCode = 28
SigmodWithNoAvailableCodePercentOfImplementation = 62.2
SigmodWithArticleCode = 3
SigmodWithArticleCodePercentOfImplementation = 6.7
SigmodWithArticleCodePercentOfAvailableCode = 17.6
SigmodWithGoogleCode = 6
SigmodWithGoogleCodePercentOfImplementation = 13.3
SigmodWithGoogleCodePercentOfAvailableCode = 35.3
SigmodWithEmailCode = 8
SigmodWithEmailCodePercentOfImplementation = 17.8
SigmodWithEmailCodePercentOfAvailableCode = 47.1
AsplosNSF = 37
AsplosWithImplementation = 30
AsplosWithImplementationPercentOfNSF = 81.1
AsplosWithNoImplementation = 7
AsplosWithNoImplementationPercentOfNSF = 18.9
AsplosWithAvailableCode = 7
AsplosWithAvailableCodePercentOfImplementation = 23.3
AsplosWithNoAvailableCode = 23
AsplosWithNoAvailableCodePercentOfImplementation = 76.7
AsplosWithArticleCode = 2
AsplosWithArticleCodePercentOfImplementation = 6.7
AsplosWithArticleCodePercentOfAvailableCode = 28.6
AsplosWithGoogleCode = 1
AsplosWithGoogleCodePercentOfImplementation = 3.3
AsplosWithGoogleCodePercentOfAvailableCode = 14.3
AsplosWithEmailCode = 4
AsplosWithEmailCodePercentOfImplementation = 13.3
AsplosWithEmailCodePercentOfAvailableCode = 57.1
OopslaNSF = 81
OopslaWithImplementation = 66
OopslaWithImplementationPercentOfNSF = 81.5
OopslaWithNoImplementation = 15
OopslaWithNoImplementationPercentOfNSF = 18.5
OopslaWithAvailableCode = 45
OopslaWithAvailableCodePercentOfImplementation = 68.2
OopslaWithNoAvailableCode = 21
OopslaWithNoAvailableCodePercentOfImplementation = 31.8
OopslaWithArticleCode = 30
OopslaWithArticleCodePercentOfImplementation = 45.5
OopslaWithArticleCodePercentOfAvailableCode = 66.7
OopslaWithGoogleCode = 6
OopslaWithGoogleCodePercentOfImplementation = 9.1
OopslaWithGoogleCodePercentOfAvailableCode = 13.3
OopslaWithEmailCode = 9
OopslaWithEmailCodePercentOfImplementation = 13.6
OopslaWithEmailCodePercentOfAvailableCode = 20.0
ToplasNSF = 15
ToplasWithImplementation = 10
ToplasWithImplementationPercentOfNSF = 66.7
ToplasWithNoImplementation = 5
ToplasWithNoImplementationPercentOfNSF = 33.3
ToplasWithAvailableCode = 8
ToplasWithAvailableCodePercentOfImplementation = 80.0
ToplasWithNoAvailableCode = 2
ToplasWithNoAvailableCodePercentOfImplementation = 20.0
ToplasWithArticleCode = 6
ToplasWithArticleCodePercentOfImplementation = 60.0
ToplasWithArticleCodePercentOfAvailableCode = 75.0
ToplasWithGoogleCode = 1
ToplasWithGoogleCodePercentOfImplementation = 10.0
ToplasWithGoogleCodePercentOfAvailableCode = 12.5
ToplasWithEmailCode = 1
ToplasWithEmailCodePercentOfImplementation = 10.0
ToplasWithEmailCodePercentOfAvailableCode = 12.5
PldiNSF = 48
PldiWithImplementation = 48
PldiWithImplementationPercentOfNSF = 100.0
PldiWithNoImplementation = 0
PldiWithNoImplementationPercentOfNSF = 0.0
PldiWithAvailableCode = 26
PldiWithAvailableCodePercentOfImplementation = 54.2
PldiWithNoAvailableCode = 22
PldiWithNoAvailableCodePercentOfImplementation = 45.8
PldiWithArticleCode = 10
PldiWithArticleCodePercentOfImplementation = 20.8
PldiWithArticleCodePercentOfAvailableCode = 38.5
PldiWithGoogleCode = 6
PldiWithGoogleCodePercentOfImplementation = 12.5
PldiWithGoogleCodePercentOfAvailableCode = 23.1
PldiWithEmailCode = 10
PldiWithEmailCodePercentOfImplementation = 20.8
PldiWithEmailCodePercentOfAvailableCode = 38.5
SospNSF = 28
SospWithImplementation = 26
SospWithImplementationPercentOfNSF = 92.9
SospWithNoImplementation = 2
SospWithNoImplementationPercentOfNSF = 7.1
SospWithAvailableCode = 9
SospWithAvailableCodePercentOfImplementation = 34.6
SospWithNoAvailableCode = 17
SospWithNoAvailableCodePercentOfImplementation = 65.4
SospWithArticleCode = 2
SospWithArticleCodePercentOfImplementation = 7.7
SospWithArticleCodePercentOfAvailableCode = 22.2
SospWithGoogleCode = 4
SospWithGoogleCodePercentOfImplementation = 15.4
SospWithGoogleCodePercentOfAvailableCode = 44.4
SospWithEmailCode = 3
SospWithEmailCodePercentOfImplementation = 11.5
SospWithEmailCodePercentOfAvailableCode = 33.3
VldbNSF = 141
VldbWithImplementation = 134
VldbWithImplementationPercentOfNSF = 95.0
VldbWithNoImplementation = 7
VldbWithNoImplementationPercentOfNSF = 5.0
VldbWithAvailableCode = 50
VldbWithAvailableCodePercentOfImplementation = 37.3
VldbWithNoAvailableCode = 84
VldbWithNoAvailableCodePercentOfImplementation = 62.7
VldbWithArticleCode = 9
VldbWithArticleCodePercentOfImplementation = 6.7
VldbWithArticleCodePercentOfAvailableCode = 18.0
VldbWithGoogleCode = 21
VldbWithGoogleCodePercentOfImplementation = 15.7
VldbWithGoogleCodePercentOfAvailableCode = 42.0
VldbWithEmailCode = 20
VldbWithEmailCodePercentOfImplementation = 14.9
VldbWithEmailCodePercentOfAvailableCode = 40.0
TocsNSF = 14
TocsWithImplementation = 13
TocsWithImplementationPercentOfNSF = 92.9
TocsWithNoImplementation = 1
TocsWithNoImplementationPercentOfNSF = 7.1
TocsWithAvailableCode = 6
TocsWithAvailableCodePercentOfImplementation = 46.2
TocsWithNoAvailableCode = 7
TocsWithNoAvailableCodePercentOfImplementation = 53.8
TocsWithArticleCode = 3
TocsWithArticleCodePercentOfImplementation = 23.1
TocsWithArticleCodePercentOfAvailableCode = 50.0
TocsWithGoogleCode = 2
TocsWithGoogleCodePercentOfImplementation = 15.4
TocsWithGoogleCodePercentOfAvailableCode = 33.3
TocsWithEmailCode = 1
TocsWithEmailCodePercentOfImplementation = 7.7
TocsWithEmailCodePercentOfAvailableCode = 16.7
CcsNSF = 76
CcsWithImplementation = 56
CcsWithImplementationPercentOfNSF = 73.7
CcsWithNoImplementation = 20
CcsWithNoImplementationPercentOfNSF = 26.3
CcsWithAvailableCode = 24
CcsWithAvailableCodePercentOfImplementation = 42.9
CcsWithNoAvailableCode = 32
CcsWithNoAvailableCodePercentOfImplementation = 57.1
CcsWithArticleCode = 4
CcsWithArticleCodePercentOfImplementation = 7.1
CcsWithArticleCodePercentOfAvailableCode = 16.7
CcsWithGoogleCode = 6
CcsWithGoogleCodePercentOfImplementation = 10.7
CcsWithGoogleCodePercentOfAvailableCode = 25.0
CcsWithEmailCode = 14
CcsWithEmailCodePercentOfImplementation = 25.0
CcsWithEmailCodePercentOfAvailableCode = 58.3
JournalsNSF = 131
JournalsWithImplementation = 85
JournalsWithImplementationPercentOfNSF = 64.9
JournalsWithNoImplementation = 46
JournalsWithNoImplementationPercentOfNSF = 35.1
JournalsWithAvailableCode = 40
JournalsWithAvailableCodePercentOfImplementation = 47.1
JournalsWithNoAvailableCode = 45
JournalsWithNoAvailableCodePercentOfImplementation = 52.9
JournalsWithArticleCode = 20
JournalsWithArticleCodePercentOfImplementation = 23.5
JournalsWithArticleCodePercentOfAvailableCode = 50.0
JournalsWithGoogleCode = 11
JournalsWithGoogleCodePercentOfImplementation = 12.9
JournalsWithGoogleCodePercentOfAvailableCode = 27.5
JournalsWithEmailCode = 9
JournalsWithEmailCodePercentOfImplementation = 10.6
JournalsWithEmailCodePercentOfAvailableCode = 22.5
ConferencesNSF = 481
ConferencesWithImplementation = 429
ConferencesWithImplementationPercentOfNSF = 89.2
ConferencesWithNoImplementation = 52
ConferencesWithNoImplementationPercentOfNSF = 10.8
ConferencesWithAvailableCode = 188
ConferencesWithAvailableCodePercentOfImplementation = 43.8
ConferencesWithNoAvailableCode = 241
ConferencesWithNoAvailableCodePercentOfImplementation = 56.2
ConferencesWithArticleCode = 64
ConferencesWithArticleCodePercentOfImplementation = 14.9
ConferencesWithArticleCodePercentOfAvailableCode = 34.0
ConferencesWithGoogleCode = 54
ConferencesWithGoogleCodePercentOfImplementation = 12.6
ConferencesWithGoogleCodePercentOfAvailableCode = 28.7
ConferencesWithEmailCode = 70
ConferencesWithEmailCodePercentOfImplementation = 16.3
ConferencesWithEmailCodePercentOfAvailableCode = 37.2
CommercialNoneNSF = 414
CommercialNoneWithImplementation = 349
CommercialNoneWithImplementationPercentOfNSF = 84.3
CommercialNoneWithNoImplementation = 65
CommercialNoneWithNoImplementationPercentOfNSF = 15.7
CommercialNoneWithAvailableCode = 178
CommercialNoneWithAvailableCodePercentOfImplementation = 51.0
CommercialNoneWithNoAvailableCode = 171
CommercialNoneWithNoAvailableCodePercentOfImplementation = 49.0
CommercialNoneWithArticleCode = 65
CommercialNoneWithArticleCodePercentOfImplementation = 18.6
CommercialNoneWithArticleCodePercentOfAvailableCode = 36.5
CommercialNoneWithGoogleCode = 53
CommercialNoneWithGoogleCodePercentOfImplementation = 15.2
CommercialNoneWithGoogleCodePercentOfAvailableCode = 29.8
CommercialNoneWithEmailCode = 60
CommercialNoneWithEmailCodePercentOfImplementation = 17.2
CommercialNoneWithEmailCodePercentOfAvailableCode = 33.7
CommercialPartNSF = 149
CommercialPartWithImplementation = 130
CommercialPartWithImplementationPercentOfNSF = 87.2
CommercialPartWithNoImplementation = 19
CommercialPartWithNoImplementationPercentOfNSF = 12.8
CommercialPartWithAvailableCode = 42
CommercialPartWithAvailableCodePercentOfImplementation = 32.3
CommercialPartWithNoAvailableCode = 88
CommercialPartWithNoAvailableCodePercentOfImplementation = 67.7
CommercialPartWithArticleCode = 13
CommercialPartWithArticleCodePercentOfImplementation = 10.0
CommercialPartWithArticleCodePercentOfAvailableCode = 31.0
CommercialPartWithGoogleCode = 12
CommercialPartWithGoogleCodePercentOfImplementation = 9.2
CommercialPartWithGoogleCodePercentOfAvailableCode = 28.6
CommercialPartWithEmailCode = 17
CommercialPartWithEmailCodePercentOfImplementation = 13.1
CommercialPartWithEmailCodePercentOfAvailableCode = 40.5
CommercialFullNSF = 49
CommercialFullWithImplementation = 35
CommercialFullWithImplementationPercentOfNSF = 71.4
CommercialFullWithNoImplementation = 14
CommercialFullWithNoImplementationPercentOfNSF = 28.6
CommercialFullWithAvailableCode = 8
CommercialFullWithAvailableCodePercentOfImplementation = 22.9
CommercialFullWithNoAvailableCode = 27
CommercialFullWithNoAvailableCodePercentOfImplementation = 77.1
CommercialFullWithArticleCode = 6
CommercialFullWithArticleCodePercentOfImplementation = 17.1
CommercialFullWithArticleCodePercentOfAvailableCode = 75.0
CommercialFullWithGoogleCode = 0
CommercialFullWithGoogleCodePercentOfImplementation = 0.0
CommercialFullWithGoogleCodePercentOfAvailableCode = 0.0
CommercialFullWithEmailCode = 2
CommercialFullWithEmailCodePercentOfImplementation = 5.7
CommercialFullWithEmailCodePercentOfAvailableCode = 25.0
NoNSFNSF = 357
NoNSFWithImplementation = 287
NoNSFWithImplementationPercentOfNSF = 80.4
NoNSFWithNoImplementation = 70
NoNSFWithNoImplementationPercentOfNSF = 19.6
NoNSFWithAvailableCode = 125
NoNSFWithAvailableCodePercentOfImplementation = 43.6
NoNSFWithNoAvailableCode = 162
NoNSFWithNoAvailableCodePercentOfImplementation = 56.4
NoNSFWithArticleCode = 48
NoNSFWithArticleCodePercentOfImplementation = 16.7
NoNSFWithArticleCodePercentOfAvailableCode = 38.4
NoNSFWithGoogleCode = 35
NoNSFWithGoogleCodePercentOfImplementation = 12.2
NoNSFWithGoogleCodePercentOfAvailableCode = 28.0
NoNSFWithEmailCode = 42
NoNSFWithEmailCodePercentOfImplementation = 14.6
NoNSFWithEmailCodePercentOfAvailableCode = 33.6
NSFNSF = 255
NSFWithImplementation = 227
NSFWithImplementationPercentOfNSF = 89.0
NSFWithNoImplementation = 28
NSFWithNoImplementationPercentOfNSF = 11.0
NSFWithAvailableCode = 103
NSFWithAvailableCodePercentOfImplementation = 45.4
NSFWithNoAvailableCode = 124
NSFWithNoAvailableCodePercentOfImplementation = 54.6
NSFWithArticleCode = 36
NSFWithArticleCodePercentOfImplementation = 15.9
NSFWithArticleCodePercentOfAvailableCode = 35.0
NSFWithGoogleCode = 30
NSFWithGoogleCodePercentOfImplementation = 13.2
NSFWithGoogleCodePercentOfAvailableCode = 29.1
NSFWithEmailCode = 37
NSFWithEmailCodePercentOfImplementation = 16.3
NSFWithEmailCodePercentOfAvailableCode = 35.9
NSFTotal = 612
NSFWithImplementation = 514
NSFWithImplementationPercentOfNSF = 84.0
NSFWithNoImplementation = 98
NSFWithNoImplementationPercentOfNSF = 16.0
NSFWithAvailableCode = 228
NSFWithAvailableCodePercentOfImplementation = 44.4
NSFWithNoAvailableCode = 286
NSFWithNoAvailableCodePercentOfImplementation = 55.6
NSFWithArticleCode = 84
NSFWithArticleCodePercentOfImplementation = 16.3
NSFWithArticleCodePercentOfAvailableCode = 36.8
NSFWithGoogleCode = 65
NSFWithGoogleCodePercentOfImplementation = 12.6
NSFWithGoogleCodePercentOfAvailableCode = 28.5
NSFWithEmailCode = 79
NSFWithEmailCodePercentOfImplementation = 15.4
NSFWithEmailCodePercentOfAvailableCode = 34.6
TissecBuildAttempted = 4
TissecBuildAttemptedPercentOfImplementation = 66.7
TissecBuildAttemptedPercentOfAvailableCode = 100.0
TissecBuildCompiles = 2
TissecBuildCompilesPercentOfAttempted = 50.0
TissecBuildDoesNotCompile = 2
TissecBuildDoesNotCompilePercentOfAttempted = 50.0
TissecBuildRuns = 2
TissecBuildRunsPercentOfAttempted = 50.0
TissecBuildCompilesDoesNotRun = 0
TissecBuildCompilesDoesNotRunPercentOfAttempted = 0.0
TissecBuildOnlineRuns = 0
TissecBuildOnlineRunsPercentOfAttempted = 0.0
TissecBuildSuccess = 2
TissecBuildSuccessPercentOfAttempted = 50.0
TissecBuildSuccessPercentOfImplementation = 33.3
TacoBuildAttempted = 14
TacoBuildAttemptedPercentOfImplementation = 35.9
TacoBuildAttemptedPercentOfAvailableCode = 100.0
TacoBuildCompiles = 6
TacoBuildCompilesPercentOfAttempted = 42.9
TacoBuildDoesNotCompile = 7
TacoBuildDoesNotCompilePercentOfAttempted = 50.0
TacoBuildRuns = 6
TacoBuildRunsPercentOfAttempted = 42.9
TacoBuildCompilesDoesNotRun = 0
TacoBuildCompilesDoesNotRunPercentOfAttempted = 0.0
TacoBuildOnlineRuns = 0
TacoBuildOnlineRunsPercentOfAttempted = 0.0
TacoBuildSuccess = 6
TacoBuildSuccessPercentOfAttempted = 42.9
TacoBuildSuccessPercentOfImplementation = 15.4
TodsBuildAttempted = 8
TodsBuildAttemptedPercentOfImplementation = 47.1
TodsBuildAttemptedPercentOfAvailableCode = 100.0
TodsBuildCompiles = 5
TodsBuildCompilesPercentOfAttempted = 62.5
TodsBuildDoesNotCompile = 3
TodsBuildDoesNotCompilePercentOfAttempted = 37.5
TodsBuildRuns = 5
TodsBuildRunsPercentOfAttempted = 62.5
TodsBuildCompilesDoesNotRun = 0
TodsBuildCompilesDoesNotRunPercentOfAttempted = 0.0
TodsBuildOnlineRuns = 0
TodsBuildOnlineRunsPercentOfAttempted = 0.0
TodsBuildSuccess = 5
TodsBuildSuccessPercentOfAttempted = 62.5
TodsBuildSuccessPercentOfImplementation = 29.4
OsdiBuildAttempted = 10
OsdiBuildAttemptedPercentOfImplementation = 41.7
OsdiBuildAttemptedPercentOfAvailableCode = 100.0
OsdiBuildCompiles = 6
OsdiBuildCompilesPercentOfAttempted = 60.0
OsdiBuildDoesNotCompile = 4
OsdiBuildDoesNotCompilePercentOfAttempted = 40.0
OsdiBuildRuns = 5
OsdiBuildRunsPercentOfAttempted = 50.0
OsdiBuildCompilesDoesNotRun = 1
OsdiBuildCompilesDoesNotRunPercentOfAttempted = 10.0
OsdiBuildOnlineRuns = 0
OsdiBuildOnlineRunsPercentOfAttempted = 0.0
OsdiBuildSuccess = 5
OsdiBuildSuccessPercentOfAttempted = 50.0
OsdiBuildSuccessPercentOfImplementation = 20.8
SigmodBuildAttempted = 17
SigmodBuildAttemptedPercentOfImplementation = 37.8
SigmodBuildAttemptedPercentOfAvailableCode = 100.0
SigmodBuildCompiles = 11
SigmodBuildCompilesPercentOfAttempted = 64.7
SigmodBuildDoesNotCompile = 6
SigmodBuildDoesNotCompilePercentOfAttempted = 35.3
SigmodBuildRuns = 9
SigmodBuildRunsPercentOfAttempted = 52.9
SigmodBuildCompilesDoesNotRun = 2
SigmodBuildCompilesDoesNotRunPercentOfAttempted = 11.8
SigmodBuildOnlineRuns = 0
SigmodBuildOnlineRunsPercentOfAttempted = 0.0
SigmodBuildSuccess = 9
SigmodBuildSuccessPercentOfAttempted = 52.9
SigmodBuildSuccessPercentOfImplementation = 20.0
AsplosBuildAttempted = 7
AsplosBuildAttemptedPercentOfImplementation = 23.3
AsplosBuildAttemptedPercentOfAvailableCode = 100.0
AsplosBuildCompiles = 4
AsplosBuildCompilesPercentOfAttempted = 57.1
AsplosBuildDoesNotCompile = 3
AsplosBuildDoesNotCompilePercentOfAttempted = 42.9
AsplosBuildRuns = 4
AsplosBuildRunsPercentOfAttempted = 57.1
AsplosBuildCompilesDoesNotRun = 0
AsplosBuildCompilesDoesNotRunPercentOfAttempted = 0.0
AsplosBuildOnlineRuns = 0
AsplosBuildOnlineRunsPercentOfAttempted = 0.0
AsplosBuildSuccess = 4
AsplosBuildSuccessPercentOfAttempted = 57.1
AsplosBuildSuccessPercentOfImplementation = 13.3
OopslaBuildAttempted = 45
OopslaBuildAttemptedPercentOfImplementation = 68.2
OopslaBuildAttemptedPercentOfAvailableCode = 100.0
OopslaBuildCompiles = 20
OopslaBuildCompilesPercentOfAttempted = 44.4
OopslaBuildDoesNotCompile = 22
OopslaBuildDoesNotCompilePercentOfAttempted = 48.9
OopslaBuildRuns = 18
OopslaBuildRunsPercentOfAttempted = 40.0
OopslaBuildCompilesDoesNotRun = 2
OopslaBuildCompilesDoesNotRunPercentOfAttempted = 4.4
OopslaBuildOnlineRuns = 3
OopslaBuildOnlineRunsPercentOfAttempted = 6.7
OopslaBuildSuccess = 21
OopslaBuildSuccessPercentOfAttempted = 46.7
OopslaBuildSuccessPercentOfImplementation = 31.8
ToplasBuildAttempted = 8
ToplasBuildAttemptedPercentOfImplementation = 80.0
ToplasBuildAttemptedPercentOfAvailableCode = 100.0
ToplasBuildCompiles = 3
ToplasBuildCompilesPercentOfAttempted = 37.5
ToplasBuildDoesNotCompile = 5
ToplasBuildDoesNotCompilePercentOfAttempted = 62.5
ToplasBuildRuns = 3
ToplasBuildRunsPercentOfAttempted = 37.5
ToplasBuildCompilesDoesNotRun = 0
ToplasBuildCompilesDoesNotRunPercentOfAttempted = 0.0
ToplasBuildOnlineRuns = 0
ToplasBuildOnlineRunsPercentOfAttempted = 0.0
ToplasBuildSuccess = 3
ToplasBuildSuccessPercentOfAttempted = 37.5
ToplasBuildSuccessPercentOfImplementation = 30.0
PldiBuildAttempted = 26
PldiBuildAttemptedPercentOfImplementation = 54.2
PldiBuildAttemptedPercentOfAvailableCode = 100.0
PldiBuildCompiles = 8
PldiBuildCompilesPercentOfAttempted = 30.8
PldiBuildDoesNotCompile = 18
PldiBuildDoesNotCompilePercentOfAttempted = 69.2
PldiBuildRuns = 3
PldiBuildRunsPercentOfAttempted = 11.5
PldiBuildCompilesDoesNotRun = 5
PldiBuildCompilesDoesNotRunPercentOfAttempted = 19.2
PldiBuildOnlineRuns = 1
PldiBuildOnlineRunsPercentOfAttempted = 3.8
PldiBuildSuccess = 4
PldiBuildSuccessPercentOfAttempted = 15.4
PldiBuildSuccessPercentOfImplementation = 8.3
SospBuildAttempted = 9
SospBuildAttemptedPercentOfImplementation = 34.6
SospBuildAttemptedPercentOfAvailableCode = 100.0
SospBuildCompiles = 2
SospBuildCompilesPercentOfAttempted = 22.2
SospBuildDoesNotCompile = 7
SospBuildDoesNotCompilePercentOfAttempted = 77.8
SospBuildRuns = 2
SospBuildRunsPercentOfAttempted = 22.2
SospBuildCompilesDoesNotRun = 0
SospBuildCompilesDoesNotRunPercentOfAttempted = 0.0
SospBuildOnlineRuns = 0
SospBuildOnlineRunsPercentOfAttempted = 0.0
SospBuildSuccess = 2
SospBuildSuccessPercentOfAttempted = 22.2
SospBuildSuccessPercentOfImplementation = 7.7
VldbBuildAttempted = 50
VldbBuildAttemptedPercentOfImplementation = 37.3
VldbBuildAttemptedPercentOfAvailableCode = 100.0
VldbBuildCompiles = 34
VldbBuildCompilesPercentOfAttempted = 68.0
VldbBuildDoesNotCompile = 16
VldbBuildDoesNotCompilePercentOfAttempted = 32.0
VldbBuildRuns = 27
VldbBuildRunsPercentOfAttempted = 54.0
VldbBuildCompilesDoesNotRun = 7
VldbBuildCompilesDoesNotRunPercentOfAttempted = 14.0
VldbBuildOnlineRuns = 0
VldbBuildOnlineRunsPercentOfAttempted = 0.0
VldbBuildSuccess = 27
VldbBuildSuccessPercentOfAttempted = 54.0
VldbBuildSuccessPercentOfImplementation = 20.1
TocsBuildAttempted = 6
TocsBuildAttemptedPercentOfImplementation = 46.2
TocsBuildAttemptedPercentOfAvailableCode = 100.0
TocsBuildCompiles = 1
TocsBuildCompilesPercentOfAttempted = 16.7
TocsBuildDoesNotCompile = 3
TocsBuildDoesNotCompilePercentOfAttempted = 50.0
TocsBuildRuns = 1
TocsBuildRunsPercentOfAttempted = 16.7
TocsBuildCompilesDoesNotRun = 0
TocsBuildCompilesDoesNotRunPercentOfAttempted = 0.0
TocsBuildOnlineRuns = 1
TocsBuildOnlineRunsPercentOfAttempted = 16.7
TocsBuildSuccess = 2
TocsBuildSuccessPercentOfAttempted = 33.3
TocsBuildSuccessPercentOfImplementation = 15.4
CcsBuildAttempted = 24
CcsBuildAttemptedPercentOfImplementation = 42.9
CcsBuildAttemptedPercentOfAvailableCode = 100.0
CcsBuildCompiles = 12
CcsBuildCompilesPercentOfAttempted = 50.0
CcsBuildDoesNotCompile = 12
CcsBuildDoesNotCompilePercentOfAttempted = 50.0
CcsBuildRuns = 8
CcsBuildRunsPercentOfAttempted = 33.3
CcsBuildCompilesDoesNotRun = 4
CcsBuildCompilesDoesNotRunPercentOfAttempted = 16.7
CcsBuildOnlineRuns = 0
CcsBuildOnlineRunsPercentOfAttempted = 0.0
CcsBuildSuccess = 8
CcsBuildSuccessPercentOfAttempted = 33.3
CcsBuildSuccessPercentOfImplementation = 14.3
JournalsBuildAttempted = 40
JournalsBuildAttemptedPercentOfImplementation = 47.1
JournalsBuildAttemptedPercentOfAvailableCode = 100.0
JournalsBuildCompiles = 17
JournalsBuildCompilesPercentOfAttempted = 42.5
JournalsBuildDoesNotCompile = 20
JournalsBuildDoesNotCompilePercentOfAttempted = 50.0
JournalsBuildRuns = 17
JournalsBuildRunsPercentOfAttempted = 42.5
JournalsBuildCompilesDoesNotRun = 0
JournalsBuildCompilesDoesNotRunPercentOfAttempted = 0.0
JournalsBuildOnlineRuns = 1
JournalsBuildOnlineRunsPercentOfAttempted = 2.5
JournalsBuildSuccess = 18
JournalsBuildSuccessPercentOfAttempted = 45.0
JournalsBuildSuccessPercentOfImplementation = 21.2
ConferencesBuildAttempted = 188
ConferencesBuildAttemptedPercentOfImplementation = 43.8
ConferencesBuildAttemptedPercentOfAvailableCode = 100.0
ConferencesBuildCompiles = 97
ConferencesBuildCompilesPercentOfAttempted = 51.6
ConferencesBuildDoesNotCompile = 88
ConferencesBuildDoesNotCompilePercentOfAttempted = 46.8
ConferencesBuildRuns = 76
ConferencesBuildRunsPercentOfAttempted = 40.4
ConferencesBuildCompilesDoesNotRun = 21
ConferencesBuildCompilesDoesNotRunPercentOfAttempted = 11.2
ConferencesBuildOnlineRuns = 4
ConferencesBuildOnlineRunsPercentOfAttempted = 2.1
ConferencesBuildSuccess = 80
ConferencesBuildSuccessPercentOfAttempted = 42.6
ConferencesBuildSuccessPercentOfImplementation = 18.6
CommercialNoneBuildAttempted = 177
CommercialNoneBuildAttemptedPercentOfImplementation = 50.7
CommercialNoneBuildAttemptedPercentOfAvailableCode = 99.4
CommercialNoneBuildCompiles = 89
CommercialNoneBuildCompilesPercentOfAttempted = 50.3
CommercialNoneBuildDoesNotCompile = 85
CommercialNoneBuildDoesNotCompilePercentOfAttempted = 48.0
CommercialNoneBuildRuns = 78
CommercialNoneBuildRunsPercentOfAttempted = 44.1
CommercialNoneBuildCompilesDoesNotRun = 11
CommercialNoneBuildCompilesDoesNotRunPercentOfAttempted = 6.2
CommercialNoneBuildOnlineRuns = 3
CommercialNoneBuildOnlineRunsPercentOfAttempted = 1.7
CommercialNoneBuildSuccess = 81
CommercialNoneBuildSuccessPercentOfAttempted = 45.8
CommercialNoneBuildSuccessPercentOfImplementation = 23.2
CommercialPartBuildAttempted = 43
CommercialPartBuildAttemptedPercentOfImplementation = 33.1
CommercialPartBuildAttemptedPercentOfAvailableCode = 102.4
CommercialPartBuildCompiles = 21
CommercialPartBuildCompilesPercentOfAttempted = 48.8
CommercialPartBuildDoesNotCompile = 19
CommercialPartBuildDoesNotCompilePercentOfAttempted = 44.2
CommercialPartBuildRuns = 12
CommercialPartBuildRunsPercentOfAttempted = 27.9
CommercialPartBuildCompilesDoesNotRun = 9
CommercialPartBuildCompilesDoesNotRunPercentOfAttempted = 20.9
CommercialPartBuildOnlineRuns = 2
CommercialPartBuildOnlineRunsPercentOfAttempted = 4.7
CommercialPartBuildSuccess = 14
CommercialPartBuildSuccessPercentOfAttempted = 32.6
CommercialPartBuildSuccessPercentOfImplementation = 10.8
CommercialFullBuildAttempted = 8
CommercialFullBuildAttemptedPercentOfImplementation = 22.9
CommercialFullBuildAttemptedPercentOfAvailableCode = 100.0
CommercialFullBuildCompiles = 4
CommercialFullBuildCompilesPercentOfAttempted = 50.0
CommercialFullBuildDoesNotCompile = 4
CommercialFullBuildDoesNotCompilePercentOfAttempted = 50.0
CommercialFullBuildRuns = 3
CommercialFullBuildRunsPercentOfAttempted = 37.5
CommercialFullBuildCompilesDoesNotRun = 1
CommercialFullBuildCompilesDoesNotRunPercentOfAttempted = 12.5
CommercialFullBuildOnlineRuns = 0
CommercialFullBuildOnlineRunsPercentOfAttempted = 0.0
CommercialFullBuildSuccess = 3
CommercialFullBuildSuccessPercentOfAttempted = 37.5
CommercialFullBuildSuccessPercentOfImplementation = 8.6
NoNSFBuildAttempted = 125
NoNSFBuildAttemptedPercentOfImplementation = 43.6
NoNSFBuildAttemptedPercentOfAvailableCode = 100.0
NoNSFBuildCompiles = 66
NoNSFBuildCompilesPercentOfAttempted = 52.8
NoNSFBuildDoesNotCompile = 58
NoNSFBuildDoesNotCompilePercentOfAttempted = 46.4
NoNSFBuildRuns = 54
NoNSFBuildRunsPercentOfAttempted = 43.2
NoNSFBuildCompilesDoesNotRun = 12
NoNSFBuildCompilesDoesNotRunPercentOfAttempted = 9.6
NoNSFBuildOnlineRuns = 1
NoNSFBuildOnlineRunsPercentOfAttempted = 0.8
NoNSFBuildSuccess = 55
NoNSFBuildSuccessPercentOfAttempted = 44.0
NoNSFBuildSuccessPercentOfImplementation = 19.2
NSFBuildAttempted = 103
NSFBuildAttemptedPercentOfImplementation = 45.4
NSFBuildAttemptedPercentOfAvailableCode = 100.0
NSFBuildCompiles = 48
NSFBuildCompilesPercentOfAttempted = 46.6
NSFBuildDoesNotCompile = 50
NSFBuildDoesNotCompilePercentOfAttempted = 48.5
NSFBuildRuns = 39
NSFBuildRunsPercentOfAttempted = 37.9
NSFBuildCompilesDoesNotRun = 9
NSFBuildCompilesDoesNotRunPercentOfAttempted = 8.7
NSFBuildOnlineRuns = 4
NSFBuildOnlineRunsPercentOfAttempted = 3.9
NSFBuildSuccess = 43
NSFBuildSuccessPercentOfAttempted = 41.7
NSFBuildSuccessPercentOfImplementation = 18.9
NSFBuildAttempted = 228
NSFBuildAttemptedPercentOfImplementation = 44.4
NSFBuildAttemptedPercentOfAvailableCode = 100.0
NSFBuildCompiles = 114
NSFBuildCompilesPercentOfAttempted = 50.0
NSFBuildDoesNotCompile = 108
NSFBuildDoesNotCompilePercentOfAttempted = 47.4
NSFBuildRuns = 93
NSFBuildRunsPercentOfAttempted = 40.8
NSFBuildCompilesDoesNotRun = 21
NSFBuildCompilesDoesNotRunPercentOfAttempted = 9.2
NSFBuildOnlineRuns = 5
NSFBuildOnlineRunsPercentOfAttempted = 2.2
NSFBuildSuccess = 98
NSFBuildSuccessPercentOfAttempted = 43.0
NSFBuildSuccessPercentOfImplementation = 19.1
TissecEmailNeeded = 3
TissecEmailSent = 3
TissecEmailSentPercentOfNeeded = 100.0
TissecEmailNeededNotSent = 0
TissecEmailNeededNotSentPercentOfNeeded = 0.0
TissecEmailGotReply = 3
TissecEmailGotReplyPercentOfSent = 100.0
TissecEmailWithoutReply = 0
TissecEmailWithoutReplyPercentOfSent = 0.0
TissecEmailGotReplyYes = 1
TissecEmailGotReplyYesPercentOfSent = 33.3
TissecEmailGotReplyYesPercentOfReply = 33.3
TissecEmailGotReplyNo = 2
TissecEmailGotReplyNoPercentOfSent = 66.7
TissecEmailGotReplyNoPercentOfReply = 66.7
TacoEmailNeeded = 29
TacoEmailSent = 27
TacoEmailSentPercentOfNeeded = 93.1
TacoEmailNeededNotSent = 2
TacoEmailNeededNotSentPercentOfNeeded = 6.9
TacoEmailGotReply = 21
TacoEmailGotReplyPercentOfSent = 77.8
TacoEmailWithoutReply = 6
TacoEmailWithoutReplyPercentOfSent = 22.2
TacoEmailGotReplyYes = 4
TacoEmailGotReplyYesPercentOfSent = 14.8
TacoEmailGotReplyYesPercentOfReply = 19.0
TacoEmailGotReplyNo = 17
TacoEmailGotReplyNoPercentOfSent = 63.0
TacoEmailGotReplyNoPercentOfReply = 81.0
TodsEmailNeeded = 11
TodsEmailSent = 11
TodsEmailSentPercentOfNeeded = 100.0
TodsEmailNeededNotSent = 0
TodsEmailNeededNotSentPercentOfNeeded = 0.0
TodsEmailGotReply = 6
TodsEmailGotReplyPercentOfSent = 54.5
TodsEmailWithoutReply = 5
TodsEmailWithoutReplyPercentOfSent = 45.5
TodsEmailGotReplyYes = 2
TodsEmailGotReplyYesPercentOfSent = 18.2
TodsEmailGotReplyYesPercentOfReply = 33.3
TodsEmailGotReplyNo = 4
TodsEmailGotReplyNoPercentOfSent = 36.4
TodsEmailGotReplyNoPercentOfReply = 66.7
OsdiEmailNeeded = 16
OsdiEmailSent = 9
OsdiEmailSentPercentOfNeeded = 56.3
OsdiEmailNeededNotSent = 7
OsdiEmailNeededNotSentPercentOfNeeded = 43.8
OsdiEmailGotReply = 9
OsdiEmailGotReplyPercentOfSent = 100.0
OsdiEmailWithoutReply = 0
OsdiEmailWithoutReplyPercentOfSent = 0.0
OsdiEmailGotReplyYes = 2
OsdiEmailGotReplyYesPercentOfSent = 22.2
OsdiEmailGotReplyYesPercentOfReply = 22.2
OsdiEmailGotReplyNo = 7
OsdiEmailGotReplyNoPercentOfSent = 77.8
OsdiEmailGotReplyNoPercentOfReply = 77.8
SigmodEmailNeeded = 36
SigmodEmailSent = 16
SigmodEmailSentPercentOfNeeded = 44.4
SigmodEmailNeededNotSent = 20
SigmodEmailNeededNotSentPercentOfNeeded = 55.6
SigmodEmailGotReply = 14
SigmodEmailGotReplyPercentOfSent = 87.5
SigmodEmailWithoutReply = 2
SigmodEmailWithoutReplyPercentOfSent = 12.5
SigmodEmailGotReplyYes = 8
SigmodEmailGotReplyYesPercentOfSent = 50.0
SigmodEmailGotReplyYesPercentOfReply = 57.1
SigmodEmailGotReplyNo = 7
SigmodEmailGotReplyNoPercentOfSent = 43.8
SigmodEmailGotReplyNoPercentOfReply = 50.0
AsplosEmailNeeded = 27
AsplosEmailSent = 20
AsplosEmailSentPercentOfNeeded = 74.1
AsplosEmailNeededNotSent = 7
AsplosEmailNeededNotSentPercentOfNeeded = 25.9
AsplosEmailGotReply = 19
AsplosEmailGotReplyPercentOfSent = 95.0
AsplosEmailWithoutReply = 1
AsplosEmailWithoutReplyPercentOfSent = 5.0
AsplosEmailGotReplyYes = 4
AsplosEmailGotReplyYesPercentOfSent = 20.0
AsplosEmailGotReplyYesPercentOfReply = 21.1
AsplosEmailGotReplyNo = 15
AsplosEmailGotReplyNoPercentOfSent = 75.0
AsplosEmailGotReplyNoPercentOfReply = 78.9
OopslaEmailNeeded = 30
OopslaEmailSent = 25
OopslaEmailSentPercentOfNeeded = 83.3
OopslaEmailNeededNotSent = 5
OopslaEmailNeededNotSentPercentOfNeeded = 16.7
OopslaEmailGotReply = 24
OopslaEmailGotReplyPercentOfSent = 96.0
OopslaEmailWithoutReply = 1
OopslaEmailWithoutReplyPercentOfSent = 4.0
OopslaEmailGotReplyYes = 9
OopslaEmailGotReplyYesPercentOfSent = 36.0
OopslaEmailGotReplyYesPercentOfReply = 37.5
OopslaEmailGotReplyNo = 15
OopslaEmailGotReplyNoPercentOfSent = 60.0
OopslaEmailGotReplyNoPercentOfReply = 62.5
ToplasEmailNeeded = 3
ToplasEmailSent = 1
ToplasEmailSentPercentOfNeeded = 33.3
ToplasEmailNeededNotSent = 2
ToplasEmailNeededNotSentPercentOfNeeded = 66.7
ToplasEmailGotReply = 1
ToplasEmailGotReplyPercentOfSent = 100.0
ToplasEmailWithoutReply = 0
ToplasEmailWithoutReplyPercentOfSent = 0.0
ToplasEmailGotReplyYes = 1
ToplasEmailGotReplyYesPercentOfSent = 100.0
ToplasEmailGotReplyYesPercentOfReply = 100.0
ToplasEmailGotReplyNo = 0
ToplasEmailGotReplyNoPercentOfSent = 0.0
ToplasEmailGotReplyNoPercentOfReply = 0.0
PldiEmailNeeded = 32
PldiEmailSent = 25
PldiEmailSentPercentOfNeeded = 78.1
PldiEmailNeededNotSent = 7
PldiEmailNeededNotSentPercentOfNeeded = 21.9
PldiEmailGotReply = 24
PldiEmailGotReplyPercentOfSent = 96.0
PldiEmailWithoutReply = 1
PldiEmailWithoutReplyPercentOfSent = 4.0
PldiEmailGotReplyYes = 10
PldiEmailGotReplyYesPercentOfSent = 40.0
PldiEmailGotReplyYesPercentOfReply = 41.7
PldiEmailGotReplyNo = 14
PldiEmailGotReplyNoPercentOfSent = 56.0
PldiEmailGotReplyNoPercentOfReply = 58.3
SospEmailNeeded = 20
SospEmailSent = 13
SospEmailSentPercentOfNeeded = 65.0
SospEmailNeededNotSent = 7
SospEmailNeededNotSentPercentOfNeeded = 35.0
SospEmailGotReply = 11
SospEmailGotReplyPercentOfSent = 84.6
SospEmailWithoutReply = 2
SospEmailWithoutReplyPercentOfSent = 15.4
SospEmailGotReplyYes = 3
SospEmailGotReplyYesPercentOfSent = 23.1
SospEmailGotReplyYesPercentOfReply = 27.3
SospEmailGotReplyNo = 8
SospEmailGotReplyNoPercentOfSent = 61.5
SospEmailGotReplyNoPercentOfReply = 72.7
VldbEmailNeeded = 104
VldbEmailSent = 74
VldbEmailSentPercentOfNeeded = 71.2
VldbEmailNeededNotSent = 30
VldbEmailNeededNotSentPercentOfNeeded = 28.8
VldbEmailGotReply = 63
VldbEmailGotReplyPercentOfSent = 85.1
VldbEmailWithoutReply = 11
VldbEmailWithoutReplyPercentOfSent = 14.9
VldbEmailGotReplyYes = 20
VldbEmailGotReplyYesPercentOfSent = 27.0
VldbEmailGotReplyYesPercentOfReply = 31.7
VldbEmailGotReplyNo = 43
VldbEmailGotReplyNoPercentOfSent = 58.1
VldbEmailGotReplyNoPercentOfReply = 68.3
TocsEmailNeeded = 8
TocsEmailSent = 8
TocsEmailSentPercentOfNeeded = 100.0
TocsEmailNeededNotSent = 0
TocsEmailNeededNotSentPercentOfNeeded = 0.0
TocsEmailGotReply = 6
TocsEmailGotReplyPercentOfSent = 75.0
TocsEmailWithoutReply = 2
TocsEmailWithoutReplyPercentOfSent = 25.0
TocsEmailGotReplyYes = 1
TocsEmailGotReplyYesPercentOfSent = 12.5
TocsEmailGotReplyYesPercentOfReply = 16.7
TocsEmailGotReplyNo = 5
TocsEmailGotReplyNoPercentOfSent = 62.5
TocsEmailGotReplyNoPercentOfReply = 83.3
CcsEmailNeeded = 46
CcsEmailSent = 28
CcsEmailSentPercentOfNeeded = 60.9
CcsEmailNeededNotSent = 18
CcsEmailNeededNotSentPercentOfNeeded = 39.1
CcsEmailGotReply = 26
CcsEmailGotReplyPercentOfSent = 92.9
CcsEmailWithoutReply = 2
CcsEmailWithoutReplyPercentOfSent = 7.1
CcsEmailGotReplyYes = 14
CcsEmailGotReplyYesPercentOfSent = 50.0
CcsEmailGotReplyYesPercentOfReply = 53.8
CcsEmailGotReplyNo = 12
CcsEmailGotReplyNoPercentOfSent = 42.9
CcsEmailGotReplyNoPercentOfReply = 46.2
JournalsEmailNeeded = 54
JournalsEmailSent = 50
JournalsEmailSentPercentOfNeeded = 92.6
JournalsEmailNeededNotSent = 4
JournalsEmailNeededNotSentPercentOfNeeded = 7.4
JournalsEmailGotReply = 37
JournalsEmailGotReplyPercentOfSent = 74.0
JournalsEmailWithoutReply = 13
JournalsEmailWithoutReplyPercentOfSent = 26.0
JournalsEmailGotReplyYes = 9
JournalsEmailGotReplyYesPercentOfSent = 18.0
JournalsEmailGotReplyYesPercentOfReply = 24.3
JournalsEmailGotReplyNo = 28
JournalsEmailGotReplyNoPercentOfSent = 56.0
JournalsEmailGotReplyNoPercentOfReply = 75.7
ConferencesEmailNeeded = 311
ConferencesEmailSent = 210
ConferencesEmailSentPercentOfNeeded = 67.5
ConferencesEmailNeededNotSent = 101
ConferencesEmailNeededNotSentPercentOfNeeded = 32.5
ConferencesEmailGotReply = 190
ConferencesEmailGotReplyPercentOfSent = 90.5
ConferencesEmailWithoutReply = 20
ConferencesEmailWithoutReplyPercentOfSent = 9.5
ConferencesEmailGotReplyYes = 70
ConferencesEmailGotReplyYesPercentOfSent = 33.3
ConferencesEmailGotReplyYesPercentOfReply = 36.8
ConferencesEmailGotReplyNo = 121
ConferencesEmailGotReplyNoPercentOfSent = 57.6
ConferencesEmailGotReplyNoPercentOfReply = 63.7
CommercialNoneEmailNeeded = 231
CommercialNoneEmailSent = 168
CommercialNoneEmailSentPercentOfNeeded = 72.7
CommercialNoneEmailNeededNotSent = 63
CommercialNoneEmailNeededNotSentPercentOfNeeded = 27.3
CommercialNoneEmailGotReply = 146
CommercialNoneEmailGotReplyPercentOfSent = 86.9
CommercialNoneEmailWithoutReply = 22
CommercialNoneEmailWithoutReplyPercentOfSent = 13.1
CommercialNoneEmailGotReplyYes = 60
CommercialNoneEmailGotReplyYesPercentOfSent = 35.7
CommercialNoneEmailGotReplyYesPercentOfReply = 41.1
CommercialNoneEmailGotReplyNo = 87
CommercialNoneEmailGotReplyNoPercentOfSent = 51.8
CommercialNoneEmailGotReplyNoPercentOfReply = 59.6
CommercialPartEmailNeeded = 105
CommercialPartEmailSent = 69
CommercialPartEmailSentPercentOfNeeded = 65.7
CommercialPartEmailNeededNotSent = 36
CommercialPartEmailNeededNotSentPercentOfNeeded = 34.3
CommercialPartEmailGotReply = 61
CommercialPartEmailGotReplyPercentOfSent = 88.4
CommercialPartEmailWithoutReply = 8
CommercialPartEmailWithoutReplyPercentOfSent = 11.6
CommercialPartEmailGotReplyYes = 17
CommercialPartEmailGotReplyYesPercentOfSent = 24.6
CommercialPartEmailGotReplyYesPercentOfReply = 27.9
CommercialPartEmailGotReplyNo = 44
CommercialPartEmailGotReplyNoPercentOfSent = 63.8
CommercialPartEmailGotReplyNoPercentOfReply = 72.1
CommercialFullEmailNeeded = 29
CommercialFullEmailSent = 23
CommercialFullEmailSentPercentOfNeeded = 79.3
CommercialFullEmailNeededNotSent = 6
CommercialFullEmailNeededNotSentPercentOfNeeded = 20.7
CommercialFullEmailGotReply = 20
CommercialFullEmailGotReplyPercentOfSent = 87.0
CommercialFullEmailWithoutReply = 3
CommercialFullEmailWithoutReplyPercentOfSent = 13.0
CommercialFullEmailGotReplyYes = 2
CommercialFullEmailGotReplyYesPercentOfSent = 8.7
CommercialFullEmailGotReplyYesPercentOfReply = 10.0
CommercialFullEmailGotReplyNo = 18
CommercialFullEmailGotReplyNoPercentOfSent = 78.3
CommercialFullEmailGotReplyNoPercentOfReply = 90.0
NoNSFEmailNeeded = 204
NoNSFEmailSent = 153
NoNSFEmailSentPercentOfNeeded = 75.0
NoNSFEmailNeededNotSent = 51
NoNSFEmailNeededNotSentPercentOfNeeded = 25.0
NoNSFEmailGotReply = 134
NoNSFEmailGotReplyPercentOfSent = 87.6
NoNSFEmailWithoutReply = 19
NoNSFEmailWithoutReplyPercentOfSent = 12.4
NoNSFEmailGotReplyYes = 42
NoNSFEmailGotReplyYesPercentOfSent = 27.5
NoNSFEmailGotReplyYesPercentOfReply = 31.3
NoNSFEmailGotReplyNo = 92
NoNSFEmailGotReplyNoPercentOfSent = 60.1
NoNSFEmailGotReplyNoPercentOfReply = 68.7
NSFEmailNeeded = 161
NSFEmailSent = 107
NSFEmailSentPercentOfNeeded = 66.5
NSFEmailNeededNotSent = 54
NSFEmailNeededNotSentPercentOfNeeded = 33.5
NSFEmailGotReply = 93
NSFEmailGotReplyPercentOfSent = 86.9
NSFEmailWithoutReply = 14
NSFEmailWithoutReplyPercentOfSent = 13.1
NSFEmailGotReplyYes = 37
NSFEmailGotReplyYesPercentOfSent = 34.6
NSFEmailGotReplyYesPercentOfReply = 39.8
NSFEmailGotReplyNo = 57
NSFEmailGotReplyNoPercentOfSent = 53.3
NSFEmailGotReplyNoPercentOfReply = 61.3
NSFEmailNeeded = 365
NSFEmailSent = 260
NSFEmailSentPercentOfNeeded = 71.2
NSFEmailNeededNotSent = 105
NSFEmailNeededNotSentPercentOfNeeded = 28.8
NSFEmailGotReply = 227
NSFEmailGotReplyPercentOfSent = 87.3
NSFEmailWithoutReply = 33
NSFEmailWithoutReplyPercentOfSent = 12.7
NSFEmailGotReplyYes = 79
NSFEmailGotReplyYesPercentOfSent = 30.4
NSFEmailGotReplyYesPercentOfReply = 34.8
NSFEmailGotReplyNo = 149
NSFEmailGotReplyNoPercentOfSent = 57.3
NSFEmailGotReplyNoPercentOfReply = 65.6
##################################################################
#titleOn = False
titleOn = True

def title(t):
   if titleOn:
      return t
   else:
      return ''

##################################################################

fig = plt.figure()
ax = fig.add_subplot(1, 1, 1, xticks=[], yticks=[], title="")
sankey = Sankey(ax=ax, 
                scale=0.8, 
                offset=0.15, 
#                gap=0.2,
                head_angle=90,
                margin=0.0,
                format='%.0f', 
                unit=None)

########################################################################
# diagram 0
########################################################################
sankey.add(
   flows=[
      NSFTotal/NSFTotal,
         -NSFWithNoImplementation/NSFTotal,
         -NSFWithImplementation/NSFTotal,
    ],
    labels=[
       str(NSFTotal), 
       title('Theoretical\n') + str(NSFWithNoImplementation), 
        '', 
    ],
    orientations=[
         0, 1, 0
    ],
    pathlengths = [0.0, 0.2, 0.0],
    linewidth=0.0,
    trunklength=1.0
)
########################################################################
# diagram 1
########################################################################
sankey.add(
   flows=[
       NSFWithImplementation/NSFTotal,
          -NSFWithArticleCode/NSFTotal,
          -NSFWithGoogleCode/NSFTotal,
          -NSFWithEmailCode/NSFTotal,
         -(NSFEmailWithoutReply+NSFEmailGotReplyNo)/NSFTotal,
          -NSFEmailNeededNotSent/NSFTotal,
    ],
    labels=[
       str(NSFWithImplementation), 
       title('Article\n') + str(NSFWithArticleCode), 
       title('Web\n') + str(NSFWithGoogleCode), 
       title('Email\n') + str(NSFWithEmailCode), 
       '',
       title('Email\nNot Sent\n') + str(NSFEmailNeededNotSent), 
    ],
    orientations=[
         0, 1, 1, 1, 0, -1
    ],
   prior=0, 
   connect=(2, 0),
   trunklength = 0.5,
   linewidth=0.0,
   pathlengths = [0.1, 0.09, 0.21, 0.29, 0.1, 0.15]
)
########################################################################
# diagram 2
########################################################################
sankey.add(
   flows=[
          NSFWithArticleCode/NSFTotal,
          NSFWithGoogleCode/NSFTotal,
          NSFWithEmailCode/NSFTotal,
          -NSFWithAvailableCode/NSFTotal
    ],
    labels=[
       '',
       '',
       '',
       ''
    ],
    orientations=[
         -1, -1, -1, 0
    ],
   prior=1, 
   connect=(1, 0),
   trunklength = 0.6,
   linewidth=0.0,
   pathlengths = [0.5, 0.5, 0.5, 0.0]
)
 
########################################################################
# diagram 3
########################################################################
sankey.add(
   flows=[
       NSFWithAvailableCode/NSFTotal,
           -NSFBuildDoesNotCompile/NSFTotal,
           -NSFBuildCompilesDoesNotRun/NSFTotal,
           -NSFBuildRuns/NSFTotal,
           -NSFBuildOnlineRuns/NSFTotal
    ],
    labels=[
       str(NSFWithAvailableCode),
       title('Build\nfails\n') + str(NSFBuildDoesNotCompile), 
       title('Run\nfails\n') + str(NSFBuildCompilesDoesNotRun), 
       title('Builds\n& runs\n') + str(NSFBuildRuns), 
       title('Online\nruns\n') + str(NSFBuildOnlineRuns)
    ],
    orientations=[
        0, -1, -1, 1, 1
    ],
   prior=2, 
   connect=(3, 0),
   trunklength = 0.6,
   linewidth=0.0,
   pathlengths = [0.0, 0.4, 0.2, 0.1, 0.1]
)
########################################################################
# diagram 4
########################################################################
sankey.add(
   flows=[
       (NSFEmailWithoutReply+NSFEmailGotReplyNo)/NSFTotal,
          -NSFEmailGotReplyNo/NSFTotal,
          -NSFEmailWithoutReply/NSFTotal,
    ],
    labels=[
       str(NSFEmailWithoutReply+NSFEmailGotReplyNo), 
       title('Email\nreply=no\n') + str(NSFEmailGotReplyNo), 
       title('No email\nreply\n') + str(NSFEmailWithoutReply), 
    ],
    orientations=[
         0, -1, -1
    ],
   prior=1, 
   connect=(4, 0),
   trunklength = 0.7,
   linewidth=0.0,
   pathlengths = [0.0, 0.3, 0.2]
)

########################################################################
diagrams = sankey.finish()

diagrams[0].patch.set_facecolor('#80b060')
diagrams[1].patch.set_facecolor('#90c070')
diagrams[2].patch.set_facecolor('#90c070')
diagrams[3].patch.set_facecolor('#a0d080') 
diagrams[4].patch.set_facecolor('#a0d080') 

diagrams[1].texts[4].set_color('r')
diagrams[1].texts[5].set_color('b')
diagrams[3].texts[1].set_color('r')
diagrams[3].texts[2].set_color('r')
diagrams[4].texts[1].set_color('r')
diagrams[4].texts[2].set_color('r')

fig.patch.set_visible(False)
ax.axis('off')
fig.tight_layout()
plt.savefig(filename='sankey-overview.pdf',frameon=False) 
plt.savefig(filename='sankey-overview.png',frameon=False) 
#plt.show()
